var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import finalizeType from '../parse/finalize-type';
import parseType from '../parse/parse-type';
import { pathToStr } from '../utils';

export default function constant(constValue) {
  var _number$string$boolea;

  var type = (_number$string$boolea = {
    number: Number,
    string: String
  }, _number$string$boolea['boolean'] = Boolean, _number$string$boolea)[typeof constValue];

  function Constant(options) {
    var moniker = [].concat(options.typeMoniker);

    if (!type || constValue !== constValue) throw new Error('Currently only number, string and boolean constants are supported for constant "' + pathToStr(moniker) + '"');

    var thisType = parseType(_extends({}, options), type);
    thisType.name = 'constant(' + constValue + ')';

    thisType.validateData = function (value, instancePath) {
      instancePath = instancePath || options.typeMoniker;
      if (value !== constValue) {
        return 'Value of "' + pathToStr(instancePath) + '" data must be ' + value;
      }
    };

    thisType.coerceData = function () {
      return constValue;
    };

    var origValidateAssign = thisType.validateAssign;
    thisType.validateAssign = function (value, instancePath) {
      instancePath = instancePath || options.typeMoniker;
      var message = origValidateAssign(value, instancePath);
      if (message) return message;
      if (value !== constValue) {
        var display = typeof constValue === 'string' ? '"' + constValue + '"' : String(constValue);
        return 'Value of "' + pathToStr(instancePath) + '" must be ' + display;
      }
    };

    thisType.defaultValue = function () {
      return constValue;
    };

    if (thisType.origPack) {
      thisType.pack = thisType.origPack;
      delete type.origPack;
    }

    return finalizeType(thisType);
  }

  Constant.isType = true;
  return Constant;
}