'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = constant;

var _finalizeType = require('../parse/finalize-type');

var _finalizeType2 = _interopRequireDefault(_finalizeType);

var _parseType = require('../parse/parse-type');

var _parseType2 = _interopRequireDefault(_parseType);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function constant(constValue) {
  var _number$string$boolea;

  var type = (_number$string$boolea = {
    number: Number,
    string: String
  }, _number$string$boolea['boolean'] = Boolean, _number$string$boolea)[typeof constValue];

  function Constant(options) {
    var moniker = [].concat(options.typeMoniker);

    if (!type || constValue !== constValue) throw new Error('Currently only number, string and boolean constants are supported for constant "' + (0, _utils.pathToStr)(moniker) + '"');

    var thisType = (0, _parseType2['default'])(_extends({}, options), type);
    thisType.name = 'constant(' + constValue + ')';

    thisType.validateData = function (value, instancePath) {
      instancePath = instancePath || options.typeMoniker;
      if (value !== constValue) {
        return 'Value of "' + (0, _utils.pathToStr)(instancePath) + '" data must be ' + value;
      }
    };

    thisType.coerceData = function () {
      return constValue;
    };

    var origValidateAssign = thisType.validateAssign;
    thisType.validateAssign = function (value, instancePath) {
      instancePath = instancePath || options.typeMoniker;
      var message = origValidateAssign(value, instancePath);
      if (message) return message;
      if (value !== constValue) {
        var display = typeof constValue === 'string' ? '"' + constValue + '"' : String(constValue);
        return 'Value of "' + (0, _utils.pathToStr)(instancePath) + '" must be ' + display;
      }
    };

    thisType.defaultValue = function () {
      return constValue;
    };

    if (thisType.origPack) {
      thisType.pack = thisType.origPack;
      delete type.origPack;
    }

    return (0, _finalizeType2['default'])(thisType);
  }

  Constant.isType = true;
  return Constant;
}